#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in float depthLevel;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0).rrrr * vertexColor * ColorModulator;
    if (color.a < 0.1) { 
        discard;
    }
	
	// Minecraft Text
	if (color.r > 0.2479 && color.r < 0.2481
        && color.g > 0.2479 && color.g < 0.2481
        && color.b > 0.2479 && color.b < 0.2481) {
        color = vec4(1.0, 1.0, 1.0, color.a);
    } 

    // Applied Energistics Text
    // depthLevel 200 is what the numbers in the ME system use. I'm telling it not to edit that. 
    // Also, I used the default color of the text color in the "screens/common/pallete.json" file in AE2's default resources.
    if (color.r > 0.2519 && color.r < 0.2521
        && color.g > 0.2441 && color.g < 0.2443
        && color.b > 0.3255 && color.b < 0.3257
        && depthLevel != 200) {
        color = vec4(1.0, 1.0, 1.0, color.a);
    }

    // Apothic Spawners Text
    // Had to specify depthLevel 0 because of a conflict with Mekanism
    if (color.r > 0.1976 && color.r < 0.1978
        && color.g > 0.1976 && color.g < 0.1978
        && color.b > 0.1976 && color.b < 0.1978
        && depthLevel == 0.0) {
        color = vec4(1.0, 1.0, 1.0, color.a);
    }

    // Sophisticated Storage
    if (color.r > 0.1705 && color.r < 0.1707
        && color.g > 0.1705 && color.g < 0.1707
        && color.b > 0.1705 && color.b < 0.1707) {
        color = vec4(1.0, 1.0, 1.0, color.a);
    }
	
    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
